###########################################################################
#	
#	PROGBAR sample makefile.
#	"@(#)Makefile	1.2 :/users/sccs/src/samples/progbar/s.Makefile 12/18/96 16:08:51"
#
#	Copyright (c) 1996, Willows Software Inc.  All rights reserved.
#
#	SYSTEM is the destination of a build.
#	       this is currently for installations or target=gcc only).
#		sunos linux sol24 sol86 hpux sco uware mips aix ibm
#
#	TWINDIR is the destination directory for any installations.
#
###########################################################################

# Installation command, used to control owner and privleges.
INSTALL_EXEC=install -m 0755

include $(TWINDIR)/makeinclude/Makefile.$(TARGET)

_DEBUG_OPT   = -O2 
_DEBUG_DBG   = -DDEBUG -DTRACE
_DEBUG_PROF  = 
DEBUG=$(_DEBUG_$(EXT))			# EXT allows selection of options.


_GFLAG_OPT   = 
_GFLAG_DBG   = -g 
_GFLAG_PROF  = -p 
GFLAG=$(_GFLAG_$(EXT))			# EXT allows selection of options.


TWIN_SYSINC = -I/usr/X11/lib
TWIN_SYSLIB = -L/usr/X11/lib

TWIN_WININC = -I$(TWINDIR)/include
TWIN_WINLIB = -L$(TWINDIR)/$(TWINSRC)

TWIN_AUXINC = -I$(TWINDIR)/commctrl

EXTRALIB = -lX11 -lm -ldl
SHARELIB = -ldl

CCOPTS	= $(TWIN_SYSINC) $(TWIN_WININC) $(TWIN_AUXINC) -DWIN32 -D_WIN32 -DTWIN32
CFLAGS	= $(CCOPTS) $(DEBUG) $(GFLAG) $(AUX) 

LDFLAGS = $(XLIB) -L. $(AUX) -DWIN32 -D_WIN32 -DTWIN32

CFILES =  listview.c listview.res.c

HFILES = listview.h resource.h

PRIMARY = $(CFILES) $(HFILES)

all:    ProgBar	 
		 
ProgBar:  progress.o progress.res.o
	$(C++) $(XLIB) $(LINKFLAGS) -o ProgBar progress.o \
	progress.res.o $(TWIN_SYSLIB) $(TWIN_WINLIB) \
	-lcommctrl32 -ltwin32 $(EXTRALIB) -lg++

progress.res.c :  progress.rc resource.h progress.ico
		rc $(CCOPTS) progress.rc

progress.o	:  progress.c progress.h
		$(CC) $(CFLAGS) -c progress.c

progress.res.o	: progress.res.c resource.h
		$(CC) $(CFLAGS) -c progress.res.c

#############################################################################
clean:
	rm -f *.o *.a ProgBar core *.res.c

clobber: clean

ctags:
	ctags *.c *.h >/dev/null 2>&1

sdiffs:
	@for f in $(SOURCE) $(HEADERS); do echo $$f;sdiffs $$f; done

#install: Test
#	strip Test ; $(INSTALL_EXEC) Test $(TWINDIR)/$(SYSTEM)/bin/Test

#############################################################################
